﻿Imports DotNetNuke
Imports DotNetNuke.Common
Imports DotNetNuke.Services.Exceptions
Imports DotNetNuke.Web.Mvp

Namespace $projectnamespacename$.$safeprojectname$
    Public Class Edit$safeprojectname$Presenter
        Inherits ModulePresenter(Of IEdit$safeprojectname$, Edit$safeprojectname$Model)

#Region "Private Members"
        Private Controller As I$safeprojectname$Controller
#End Region

#Region "Properties"
        Public ReadOnly Property ItemId() As Long
            Get
                Dim _ItemId As Integer = Null.NullInteger
                If Not String.IsNullOrEmpty(Request.Params("ItemId")) Then
                    _ItemId = Int32.Parse(Request.Params("ItemId"))
                End If
                Return _ItemId
            End Get
        End Property
#End Region

#Region "Constructors"
        Public Sub New(ByVal _View As IEdit$safeprojectname$)
            Me.New(_View, New $safeprojectname$Controller(New SqlDataProvider()))
        End Sub

        Public Sub New(ByVal _View As IEdit$safeprojectname$, ByVal _Controller As I$safeprojectname$Controller)
            MyBase.New(_View)
            If _Controller Is Nothing Then
                Throw New ArgumentNullException("_Controller", "_Controller is nothing.")
            End If
            Controller = _Controller

            ' add event handlers
            AddHandler View.Cancel, AddressOf Cancel
            AddHandler View.Delete, AddressOf Delete
            AddHandler View.Save, AddressOf Save
        End Sub
#End Region

#Region "Page Events"
        Protected Overrides Sub OnInit()
            MyBase.OnInit()
            If Not IsPostBack Then
                Try
                    If Not Common.Utilities.Null.NullInteger = ItemId Then
                        ' get content
                        Dim obj$safeprojectname$ As $safeprojectname$Info = Controller.Get$safeprojectname$(ModuleId, ItemId)
                        If Not obj$safeprojectname$ Is Nothing Then
                            View.Model.Item = obj$safeprojectname$
                        Else ' security violation attempt to access item not related to this Module
                            Response.Redirect(NavigateURL(TabId))
                        End If
                    Else
                        View.Model.Item = New $safeprojectname$Info(ModuleId, UserId)
                        View.ShowDeleteButton(False)
                        View.ShowAuditControl(False)
                    End If
                Catch exc As Exception
                    'Show a UI message later
                    LogException(exc)
                End Try
            End If
        End Sub

        Public Sub Cancel(ByVal sender As Object, ByVal e As EventArgs)
            Response.Redirect(NavigateURL(TabId))
        End Sub

        Public Sub Save(ByVal sender As Object, ByVal e As UIEventArgs(Of $safeprojectname$Info))
            Try
                e.Item.CreatedByUser = UserId
                e.Item.ModuleId = ModuleId
                e.Item.ItemId = ItemId

                If Common.Utilities.Null.NullInteger = ItemId Then
                    ' add the content within the $safeprojectname$ table
                    e.Item.ItemId = Controller.Add$safeprojectname$(e.Item)
                    If e.Item.ItemId = Null.NullInteger Then
                        Throw New Exception("Add Exception")
                    End If
                Else
                    ' update the content within the $safeprojectname$ table
                    Controller.Update$safeprojectname$(e.Item)
                End If
                ' Redirect back to the portal home page
                Response.Redirect(NavigateURL(TabId))
            Catch exc As Exception    'Module failed to load
                'Show a UI message later
                LogException(exc)
            End Try
        End Sub

        Public Sub Delete(ByVal sender As Object, ByVal e As EventArgs)
            Try
                ' Only attempt to delete the item if it exists already
                Dim obj$safeprojectname$ As $safeprojectname$Info = Controller.Get$safeprojectname$(ModuleId, ItemId)
                If Not obj$safeprojectname$ Is Nothing Then
                    Controller.Delete$safeprojectname$(ModuleId, ItemId)
                    ' Redirect back to the portal home page
                    Response.Redirect(NavigateURL(TabId))
                Else ' security violation attempt to access item not related to this Module
                    Response.Redirect(NavigateURL(TabId))
                End If
            Catch exc As Exception
                'Show a UI message later
                LogException(exc)
            End Try
        End Sub
#End Region

    End Class
End Namespace

