﻿Imports DotNetNuke.Web.Mvp

Namespace $projectnamespacename$.$safeprojectname$
    Public Class View$safeprojectname$Presenter
        Inherits ModulePresenter(Of IView$safeprojectname$, View$safeprojectname$Model)

#Region "Constructors"
        Public Sub New(ByVal _View As IView$safeprojectname$)
            Me.New(_View, New $safeprojectname$Controller(New SqlDataProvider()))
        End Sub

        Public Sub New(ByVal _View As IView$safeprojectname$, ByVal _Controller As I$safeprojectname$Controller)
            MyBase.New(_View)
            If _Controller Is Nothing Then
                Throw New ArgumentNullException("_Controller", "_Controller is nothing.")
            End If
            Me._Controller = _Controller
        End Sub
#End Region

#Region "Properties and Fields"
        Private _Controller As I$safeprojectname$Controller

        Protected ReadOnly Property Controller() As I$safeprojectname$Controller
            Get
                Return _Controller
            End Get
        End Property

        Private _Settings As New Dictionary(Of String, String)
        Public Property Settings() As Dictionary(Of String, String)
            Get
                Return _Settings
            End Get
            Set(ByVal value As Dictionary(Of String, String))
                _Settings = value
            End Set
        End Property

        Private ReadOnly Property FormattingTemplate() As String
            Get
                Dim formattedString As String = ""
                If CType(Settings("template"), String) <> "" Then
                    formattedString = CType(Settings("template"), String)
                End If
                Return formattedString
            End Get
        End Property
#End Region

#Region "Base Class Overrides"
        Protected Overrides Sub OnInit()
            MyBase.OnInit()
            ' The below is formally from the constructor...
            Try
                View.Model.IsEditable = IsEditable

                Dim col$safeprojectname$s As List(Of $safeprojectname$Info)

                ' get the content from the $safeprojectname$ table
                col$safeprojectname$s = Controller.Get$safeprojectname$s(ModuleId)

                If col$safeprojectname$s.Count = 0 Then
                    ' add the content to the $safeprojectname$ table
                    Dim obj$safeprojectname$ As $safeprojectname$Info = New $safeprojectname$Info
                    obj$safeprojectname$.ModuleId = ModuleId
                    obj$safeprojectname$.Content = "View.Content"
                    obj$safeprojectname$.CreatedByUser = UserId
                    obj$safeprojectname$.ItemId = Controller.Add$safeprojectname$(obj$safeprojectname$)
                    col$safeprojectname$s.Add(obj$safeprojectname$)
                End If
                For Each obj As $safeprojectname$Info In col$safeprojectname$s
                    If String.IsNullOrEmpty(FormattingTemplate.Trim) Then
                        obj.DisplayContent = obj.Content
                    Else
                        obj.DisplayContent = FormatContent(obj)
                    End If
                Next
                View.Model.$safeprojectname$s = col$safeprojectname$s
            Catch exc As Exception
                'Show a UI message later
                LogException(exc)
            End Try
        End Sub

        Protected Overrides Sub LoadFromContext()
            MyBase.LoadFromContext()
            If ModuleContext IsNot Nothing Then
                _Settings = New Dictionary(Of String, String)()
                For Each item As DictionaryEntry In ModuleContext.Settings
                    _Settings.Add(item.Key.ToString(), item.Value.ToString())
                Next
            End If
        End Sub
#End Region

#Region "Private Methods"
        Private Function FormatContent(ByRef info As $safeprojectname$Info) As String
            Dim FormatString As String = FormattingTemplate
            FormatString = FormatString.Replace("[MODULEID]", info.ModuleId.ToString())
            FormatString = FormatString.Replace("[ITEMID]", info.ItemId.ToString())
            FormatString = FormatString.Replace("[CONTENT]", info.Content)
            FormatString = FormatString.Replace("[CREATEDBYUSER]", info.CreatedByUser.ToString())
            FormatString = FormatString.Replace("[CREATEDBYUSERNAME]", info.CreatedByUserName)
            FormatString = FormatString.Replace("[CREATEDDATE]", info.CreatedDate.ToString())
            Return FormatString
        End Function
#End Region
    End Class
End Namespace


