'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2005
' by Perpetual Motion Interactive Systems Inc. ( http://www.perpetualmotion.ca )
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System
Imports System.Configuration
Imports System.Data
Imports System.XML
Imports System.Web
Imports System.Collections.Generic

Imports DotNetNuke
Imports DotNetNuke.Common
Imports DotNetNuke.Common.Utilities.XmlUtils
Imports DotNetNuke.Common.Utilities
Imports DotNetNuke.Services.Search

Namespace YourCompany.Modules.$safeprojectname$

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' The Controller class for $safeprojectname$
    ''' </summary>
    ''' <remarks>
    ''' </remarks>
    ''' <history>
    ''' </history>
    ''' -----------------------------------------------------------------------------
    Public Class $safeprojectname$Controller
        Implements I$safeprojectname$Controller
        Implements Entities.Modules.ISearchable
        Implements Entities.Modules.IPortable


#Region "Public Methods"
        Private _DataProvider As IDataProvider

        Public Sub New()
            _DataProvider = DotNetNuke.ComponentModel.ComponentFactory.GetComponent(Of IDataProvider)()
            If _DataProvider Is Nothing Then
                ' get the provider configuration based on the type
                Dim defaultprovider As String = DotNetNuke.Data.DataProvider.Instance.DefaultProviderName
                Dim dataProviderNamespace As String = "YourCompany.Modules.$safeprojectname$"
                If defaultprovider = "SqlDataProvider" Then
                    _DataProvider = New SqlDataProvider
                Else
                    Dim providerType As String = dataProviderNamespace + "." + defaultprovider
                    _DataProvider = CType(Framework.Reflection.CreateObject(providerType, providerType, True), IDataProvider)
                End If
                DotNetNuke.ComponentModel.ComponentFactory.RegisterComponentInstance(Of IDataProvider)(_DataProvider)
            End If
        End Sub

        Public Sub New(ByVal dataprovider As IDataProvider)
            _DataProvider = dataprovider
        End Sub


        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' gets an object from the database
        ''' </summary>
        ''' <remarks>
        ''' </remarks>
        ''' <param name="moduleId">The Id of the module</param>
        ''' <history>
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Public Function Get$safeprojectname$s(ByVal ModuleId As Integer) As List(Of $safeprojectname$Info) Implements I$safeprojectname$Controller.Get$safeprojectname$s

            Return CBO.FillCollection(Of $safeprojectname$Info)(_DataProvider.Get$safeprojectname$s(ModuleId))

        End Function

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' gets an object from the database
        ''' </summary>
        ''' <remarks>
        ''' </remarks>
        ''' <param name="ModuleId">The Id of the module</param>
        ''' <param name="ItemId">The Id of the item</param>
        ''' <history>
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Public Function Get$safeprojectname$(ByVal ModuleId As Integer, ByVal ItemId As Integer) As $safeprojectname$Info Implements I$safeprojectname$Controller.Get$safeprojectname$

            Return CType(CBO.FillObject(_DataProvider.Get$safeprojectname$(ModuleId, ItemId), GetType($safeprojectname$Info)), $safeprojectname$Info)

        End Function

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' adds an object to the database
        ''' </summary>
        ''' <remarks>
        ''' </remarks>
        ''' <param name="obj$safeprojectname$">The $safeprojectname$Info object</param>
        ''' <history>
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Public Function Add$safeprojectname$(ByVal obj$safeprojectname$ As $safeprojectname$Info) As Integer Implements I$safeprojectname$Controller.Add$safeprojectname$

            If obj$safeprojectname$.Content.Trim <> "" Then
                Return _DataProvider.Add$safeprojectname$(obj$safeprojectname$.ModuleId, obj$safeprojectname$.Content, obj$safeprojectname$.CreatedByUser)
            Else
                Return Null.NullInteger
            End If

        End Function

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' saves an object to the database
        ''' </summary>
        ''' <remarks>
        ''' </remarks>
        ''' <param name="obj$safeprojectname$">The $safeprojectname$Info object</param>
        ''' <history>
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Public Sub Update$safeprojectname$(ByVal obj$safeprojectname$ As $safeprojectname$Info) Implements I$safeprojectname$Controller.Update$safeprojectname$

            If obj$safeprojectname$.Content.Trim <> "" Then
                _DataProvider.Update$safeprojectname$(obj$safeprojectname$.ModuleId, obj$safeprojectname$.ItemId, obj$safeprojectname$.Content, obj$safeprojectname$.CreatedByUser)
            Else
                Throw New ArgumentException("No Content")
            End If

        End Sub

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' deletes an object from the database
        ''' </summary>
        ''' <remarks>
        ''' </remarks>
        ''' <param name="ModuleId">The Id of the module</param>
        ''' <param name="ItemId">The Id of the item</param>
        ''' <history>
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Public Sub Delete$safeprojectname$(ByVal ModuleId As Integer, ByVal ItemId As Integer) Implements I$safeprojectname$Controller.Delete$safeprojectname$

            _DataProvider.Delete$safeprojectname$(ModuleId, ItemId)

        End Sub

#End Region

#Region "Optional Interfaces"

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' GetSearchItems implements the ISearchable Interface
        ''' </summary>
        ''' <remarks>
        ''' </remarks>
        ''' <param name="ModInfo">The ModuleInfo for the module to be Indexed</param>
        ''' <history>
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Public Function GetSearchItems(ByVal ModInfo As Entities.Modules.ModuleInfo) As DotNetNuke.Services.Search.SearchItemInfoCollection Implements DotNetNuke.Entities.Modules.ISearchable.GetSearchItems

            Dim SearchItemCollection As New SearchItemInfoCollection

            Dim col$safeprojectname$s As List(Of $safeprojectname$Info) = Get$safeprojectname$s(ModInfo.ModuleID)
            Dim obj$safeprojectname$ As $safeprojectname$Info
            For Each obj$safeprojectname$ In col$safeprojectname$s
                Dim SearchItem As SearchItemInfo = New SearchItemInfo(ModInfo.ModuleTitle, obj$safeprojectname$.Content, obj$safeprojectname$.CreatedByUser, obj$safeprojectname$.CreatedDate, ModInfo.ModuleID, obj$safeprojectname$.ItemId.ToString, obj$safeprojectname$.Content, "ItemId=" & obj$safeprojectname$.ItemId.ToString)
                SearchItemCollection.Add(SearchItem)
            Next

            Return SearchItemCollection

        End Function

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' ExportModule implements the IPortable ExportModule Interface
        ''' </summary>
        ''' <remarks>
        ''' </remarks>
        ''' <param name="ModuleID">The Id of the module to be exported</param>
        ''' <history>
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Public Function ExportModule(ByVal ModuleID As Integer) As String Implements DotNetNuke.Entities.Modules.IPortable.ExportModule

            Dim strXML As String = ""

            Dim col$safeprojectname$s As List(Of $safeprojectname$Info) = Get$safeprojectname$s(ModuleID)
            If col$safeprojectname$s.Count <> 0 Then
                strXML += "<$safeprojectname$s>"
                Dim obj$safeprojectname$ As $safeprojectname$Info
                For Each obj$safeprojectname$ In col$safeprojectname$s
                    strXML += "<$safeprojectname$>"
                    strXML += "<content>" & XMLEncode(obj$safeprojectname$.Content) & "</content>"
                    strXML += "</$safeprojectname$>"
                Next
                strXML += "</$safeprojectname$s>"
            End If

            Return strXML

        End Function

        ''' -----------------------------------------------------------------------------
        ''' <summary>
        ''' ImportModule implements the IPortable ImportModule Interface
        ''' </summary>
        ''' <remarks>
        ''' </remarks>
        ''' <param name="ModuleID">The Id of the module to be imported</param>
        ''' <param name="Content">The content to be imported</param>
        ''' <param name="Version">The version of the module to be imported</param>
        ''' <param name="UserId">The Id of the user performing the import</param>
        ''' <history>
        ''' </history>
        ''' -----------------------------------------------------------------------------
        Public Sub ImportModule(ByVal ModuleID As Integer, ByVal Content As String, ByVal Version As String, ByVal UserId As Integer) Implements DotNetNuke.Entities.Modules.IPortable.ImportModule

            Dim xml$safeprojectname$ As XmlNode
            Dim xml$safeprojectname$s As XmlNode = GetContent(Content, "$safeprojectname$s")
            For Each xml$safeprojectname$ In xml$safeprojectname$s.SelectNodes("$safeprojectname$")
                Dim obj$safeprojectname$ As New $safeprojectname$Info
                obj$safeprojectname$.ModuleId = ModuleID
                obj$safeprojectname$.Content = xml$safeprojectname$.SelectSingleNode("content").InnerText
                obj$safeprojectname$.CreatedByUser = UserId
                Add$safeprojectname$(obj$safeprojectname$)
            Next

        End Sub

#End Region

    End Class
End Namespace
