﻿using System;
using System.Text;
using System.Collections.Generic;

using Microsoft.VisualStudio.TestTools.UnitTesting;
using YourCompany.Modules.$safeprojectname$;
using $safeprojectname$.Mocks;
using System.Data;
using System.Transactions;

namespace $safeprojectname$
{
    /// <summary>
    /// Summary description for SqlDataProviderFixture
    /// </summary>
    [TestClass]
    public class SqlDataProviderFixture
    {
        SqlDataProvider sqlDataProvider = new SqlDataProvider();
        public SqlDataProviderFixture()
        {
            sqlDataProvider.ConnectionString = "Server=(local);Database=DotNetNuke_Help;uid=HelpTDD;pwd=HelpTDD;";
            sqlDataProvider.ObjectQualifier = "dnn_";
            sqlDataProvider.DatabaseOwner = "dbo.";
        }

        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        [Description("Adds, retrieves and then deletes a TestDrivenModule record in the database")]
        [Owner("Philip Beadle")]
        public void AddTestDrivenModule()
        {
            using (new TransactionScope())
            {
                string content = "";

                int itemId = sqlDataProvider.Add$safeprojectname$(MockHelper.ModuleId, MockHelper.content, MockHelper.createdByUser);
                Assert.IsTrue(itemId > 0);

                IDataReader dataReader = sqlDataProvider.Get$safeprojectname$(MockHelper.ModuleId, itemId);
                if (dataReader.Read())
                {
                    content = (string)dataReader["Content"];
                }
                Assert.AreEqual<string>(MockHelper.content, content);
            }
        }

        [TestMethod]
        [Description("Adds, retrieves and then deletes a TestDrivenModule record in the database")]
        [Owner("Philip Beadle")]
        public void DeleteTestDrivenModule()
        {
            using (new TransactionScope())
            {
                string content = "";

                int itemId = sqlDataProvider.Add$safeprojectname$(MockHelper.ModuleId, MockHelper.content, MockHelper.createdByUser);
                Assert.IsTrue(itemId > 0);

                IDataReader dataReader = sqlDataProvider.Get$safeprojectname$(MockHelper.ModuleId, itemId);
                if (dataReader.Read())
                {
                    content = (string)dataReader["Content"];
                }
                Assert.AreEqual<string>(MockHelper.content, content);

                sqlDataProvider.Delete$safeprojectname$(MockHelper.ModuleId, itemId);

                dataReader = sqlDataProvider.Get$safeprojectname$(MockHelper.ModuleId, itemId);
                Assert.IsFalse(dataReader.Read());
            }
        }

        [TestMethod]
        [Description("Adds, updates and retrieves a TestDrivenModule record in the database")]
        [Owner("Philip Beadle")]
        public void Update$safeprojectname$()
        {
            using (new TransactionScope())
            {
                string content = "";

                int itemId = sqlDataProvider.Add$safeprojectname$(MockHelper.ModuleId, MockHelper.content, MockHelper.createdByUser);
                Assert.IsTrue(itemId > 0);

                sqlDataProvider.Update$safeprojectname$(MockHelper.ModuleId, itemId, MockHelper.updateContent, MockHelper.createdByUser);

                IDataReader dataReader = sqlDataProvider.Get$safeprojectname$(MockHelper.ModuleId, itemId);
                if (dataReader.Read())
                {
                    content = (string)dataReader["Content"];
                }
                Assert.AreEqual<string>(MockHelper.updateContent, content);
            }
        }

        [TestMethod]
        [Description("Adds 2 and then retrieves 2 TestDrivenModule records in the database")]
        [Owner("Philip Beadle")]
        public void Get$safeprojectname$s()
        {
            using (new TransactionScope())
            {
                int records = 0;

                int itemId1 = sqlDataProvider.Add$safeprojectname$(MockHelper.ModuleId, MockHelper.content, MockHelper.createdByUser);
                int itemId2 = sqlDataProvider.Add$safeprojectname$(MockHelper.ModuleId, MockHelper.content, MockHelper.createdByUser);
                Assert.IsTrue(itemId1 > 0);
                Assert.IsTrue(itemId2 > 0);

                IDataReader dataReader = sqlDataProvider.Get$safeprojectname$s(MockHelper.ModuleId);
                while (dataReader.Read())
                {
                    records += 1;
                }
                Assert.AreEqual<int>(2, records);
            }
        }
    }
}
