'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2005
' by Perpetual Motion Interactive Systems Inc. ( http://www.perpetualmotion.ca )
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System
Imports System.Configuration
Imports System.Data
Imports System.XML
Imports System.Web
Imports System.Collections.Generic

Imports DotNetNuke
Imports DotNetNuke.Common
Imports DotNetNuke.Common.Utilities.XmlUtils
Imports DotNetNuke.Common.Utilities
Imports DotNetNuke.Services.Search

''' -----------------------------------------------------------------------------
''' <summary>
''' The Controller class for ZParentProjectNameZ
''' </summary>
''' <remarks>
''' </remarks>
''' <history>
''' </history>
''' -----------------------------------------------------------------------------
Public Class ZParentProjectNameZController
    Implements IZParentProjectNameZController
    Implements Entities.Modules.ISearchable
    Implements Entities.Modules.IPortable


#Region "Public Methods"
    Private _DataProvider As IDataProvider

    Public Sub New()
        _DataProvider = DotNetNuke.ComponentModel.ComponentFactory.GetComponent(Of IDataProvider)()
        If _DataProvider Is Nothing Then
            ' get the provider configuration based on the type
            Dim defaultprovider As String = DotNetNuke.Data.DataProvider.Instance.DefaultProviderName
            Dim dataProviderNamespace As String = "ZProjectNamespaceNameZ.ZParentProjectNameZ"
            If defaultprovider = "SqlDataProvider" Then
                _DataProvider = New SqlDataProvider
            Else
                Dim providerType As String = dataProviderNamespace + "." + defaultprovider
                _DataProvider = CType(Framework.Reflection.CreateObject(providerType, providerType, True), IDataProvider)
            End If
            DotNetNuke.ComponentModel.ComponentFactory.RegisterComponentInstance(Of IDataProvider)(_DataProvider)
        End If
    End Sub

    Public Sub New(ByVal dataprovider As IDataProvider)
        _DataProvider = dataprovider
    End Sub


    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' gets an object from the database
    ''' </summary>
    ''' <remarks>
    ''' </remarks>
    ''' <param name="moduleId">The Id of the module</param>
    ''' <history>
    ''' </history>
    ''' -----------------------------------------------------------------------------
    Public Function GetZParentProjectNameZs(ByVal ModuleId As Integer) As List(Of ZParentProjectNameZInfo) Implements IZParentProjectNameZController.GetZParentProjectNameZs

        Return CBO.FillCollection(Of ZParentProjectNameZInfo)(_DataProvider.GetZParentProjectNameZs(ModuleId))

    End Function

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' gets an object from the database
    ''' </summary>
    ''' <remarks>
    ''' </remarks>
    ''' <param name="ModuleId">The Id of the module</param>
    ''' <param name="ItemId">The Id of the item</param>
    ''' <history>
    ''' </history>
    ''' -----------------------------------------------------------------------------
    Public Function GetZParentProjectNameZ(ByVal ModuleId As Integer, ByVal ItemId As Integer) As ZParentProjectNameZInfo Implements IZParentProjectNameZController.GetZParentProjectNameZ

        Return CType(CBO.FillObject(_DataProvider.GetZParentProjectNameZ(ModuleId, ItemId), GetType(ZParentProjectNameZInfo)), ZParentProjectNameZInfo)

    End Function

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' adds an object to the database
    ''' </summary>
    ''' <remarks>
    ''' </remarks>
    ''' <param name="objZParentProjectNameZ">The ZParentProjectNameZInfo object</param>
    ''' <history>
    ''' </history>
    ''' -----------------------------------------------------------------------------
    Public Function AddZParentProjectNameZ(ByVal objZParentProjectNameZ As ZParentProjectNameZInfo) As Integer Implements IZParentProjectNameZController.AddZParentProjectNameZ

        If objZParentProjectNameZ.Content.Trim <> "" Then
            Return _DataProvider.AddZParentProjectNameZ(objZParentProjectNameZ.ModuleId, objZParentProjectNameZ.Content, objZParentProjectNameZ.CreatedByUser)
        Else
            Return Null.NullInteger
        End If

    End Function

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' saves an object to the database
    ''' </summary>
    ''' <remarks>
    ''' </remarks>
    ''' <param name="objZParentProjectNameZ">The ZParentProjectNameZInfo object</param>
    ''' <history>
    ''' </history>
    ''' -----------------------------------------------------------------------------
    Public Sub UpdateZParentProjectNameZ(ByVal objZParentProjectNameZ As ZParentProjectNameZInfo) Implements IZParentProjectNameZController.UpdateZParentProjectNameZ

        If objZParentProjectNameZ.Content.Trim <> "" Then
            _DataProvider.UpdateZParentProjectNameZ(objZParentProjectNameZ.ModuleId, objZParentProjectNameZ.ItemId, objZParentProjectNameZ.Content, objZParentProjectNameZ.CreatedByUser)
        Else
            Throw New ArgumentException("No Content")
        End If

    End Sub

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' deletes an object from the database
    ''' </summary>
    ''' <remarks>
    ''' </remarks>
    ''' <param name="ModuleId">The Id of the module</param>
    ''' <param name="ItemId">The Id of the item</param>
    ''' <history>
    ''' </history>
    ''' -----------------------------------------------------------------------------
    Public Sub DeleteZParentProjectNameZ(ByVal ModuleId As Integer, ByVal ItemId As Integer) Implements IZParentProjectNameZController.DeleteZParentProjectNameZ

        _DataProvider.DeleteZParentProjectNameZ(ModuleId, ItemId)

    End Sub

#End Region

#Region "Optional Interfaces"

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' GetSearchItems implements the ISearchable Interface
    ''' </summary>
    ''' <remarks>
    ''' </remarks>
    ''' <param name="ModInfo">The ModuleInfo for the module to be Indexed</param>
    ''' <history>
    ''' </history>
    ''' -----------------------------------------------------------------------------
    Public Function GetSearchItems(ByVal ModInfo As Entities.Modules.ModuleInfo) As DotNetNuke.Services.Search.SearchItemInfoCollection Implements DotNetNuke.Entities.Modules.ISearchable.GetSearchItems

        Dim SearchItemCollection As New SearchItemInfoCollection

        Dim colZParentProjectNameZs As List(Of ZParentProjectNameZInfo) = GetZParentProjectNameZs(ModInfo.ModuleID)
        Dim objZParentProjectNameZ As ZParentProjectNameZInfo
        For Each objZParentProjectNameZ In colZParentProjectNameZs
            Dim SearchItem As SearchItemInfo = New SearchItemInfo(ModInfo.ModuleTitle, objZParentProjectNameZ.Content, objZParentProjectNameZ.CreatedByUser, objZParentProjectNameZ.CreatedDate, ModInfo.ModuleID, objZParentProjectNameZ.ItemId.ToString, objZParentProjectNameZ.Content, "ItemId=" & objZParentProjectNameZ.ItemId.ToString)
            SearchItemCollection.Add(SearchItem)
        Next

        Return SearchItemCollection

    End Function

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' ExportModule implements the IPortable ExportModule Interface
    ''' </summary>
    ''' <remarks>
    ''' </remarks>
    ''' <param name="ModuleID">The Id of the module to be exported</param>
    ''' <history>
    ''' </history>
    ''' -----------------------------------------------------------------------------
    Public Function ExportModule(ByVal ModuleID As Integer) As String Implements DotNetNuke.Entities.Modules.IPortable.ExportModule

        Dim strXML As String = ""

        Dim colZParentProjectNameZs As List(Of ZParentProjectNameZInfo) = GetZParentProjectNameZs(ModuleID)
        If colZParentProjectNameZs.Count <> 0 Then
            strXML += "<ZParentProjectNameZs>"
            Dim objZParentProjectNameZ As ZParentProjectNameZInfo
            For Each objZParentProjectNameZ In colZParentProjectNameZs
                strXML += "<ZParentProjectNameZ>"
                strXML += "<content>" & XMLEncode(objZParentProjectNameZ.Content) & "</content>"
                strXML += "</ZParentProjectNameZ>"
            Next
            strXML += "</ZParentProjectNameZs>"
        End If

        Return strXML

    End Function

    ''' -----------------------------------------------------------------------------
    ''' <summary>
    ''' ImportModule implements the IPortable ImportModule Interface
    ''' </summary>
    ''' <remarks>
    ''' </remarks>
    ''' <param name="ModuleID">The Id of the module to be imported</param>
    ''' <param name="Content">The content to be imported</param>
    ''' <param name="Version">The version of the module to be imported</param>
    ''' <param name="UserId">The Id of the user performing the import</param>
    ''' <history>
    ''' </history>
    ''' -----------------------------------------------------------------------------
    Public Sub ImportModule(ByVal ModuleID As Integer, ByVal Content As String, ByVal Version As String, ByVal UserId As Integer) Implements DotNetNuke.Entities.Modules.IPortable.ImportModule

        Dim xmlZParentProjectNameZ As XmlNode
        Dim xmlZParentProjectNameZs As XmlNode = GetContent(Content, "ZParentProjectNameZs")
        For Each xmlZParentProjectNameZ In xmlZParentProjectNameZs.SelectNodes("ZParentProjectNameZ")
            Dim objZParentProjectNameZ As New ZParentProjectNameZInfo
            objZParentProjectNameZ.ModuleId = ModuleID
            objZParentProjectNameZ.Content = xmlZParentProjectNameZ.SelectSingleNode("content").InnerText
            objZParentProjectNameZ.CreatedByUser = UserId
            AddZParentProjectNameZ(objZParentProjectNameZ)
        Next

    End Sub

#End Region

End Class
