'
' DotNetNuke - http://www.dotnetnuke.com
' Copyright (c) 2002-2005
' by Perpetual Motion Interactive Systems Inc. ( http://www.perpetualmotion.ca )
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'

Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports Microsoft.ApplicationBlocks.Data

Imports DotNetNuke.Common.Utilities
Imports DotNetNuke.Framework.Providers

''' -----------------------------------------------------------------------------
''' <summary>
''' SQL Server implementation of the abstract DataProvider class
''' </summary>
''' <remarks>
''' </remarks>
''' <history>
''' </history>
''' -----------------------------------------------------------------------------
Public Class SqlDataProvider
    Implements IDataProvider

#Region "Private Members"

    Private Const ModuleQualifier As String = "ZSafeYourCompanyZ_"

#End Region

#Region "Properties"
    Private _connectionString As String = String.Empty
    Public Property ConnectionString() As String
        Set(ByVal value As String)
            _connectionString = value
        End Set
        Get
            If _connectionString = String.Empty Then
                Return DotNetNuke.Data.DataProvider.Instance().ConnectionString
            Else
                Return _connectionString
            End If
        End Get
    End Property

    Private _databaseOwner As String
    Public Property DatabaseOwner() As String
        Set(ByVal value As String)
            _databaseOwner = value
        End Set
        Get
            If _databaseOwner = String.Empty Then
                Return DotNetNuke.Data.DataProvider.Instance().DatabaseOwner
            Else
                Return _databaseOwner
            End If
        End Get
    End Property

    Private _objectQualifier As String
    Public Property ObjectQualifier() As String
        Set(ByVal value As String)
            _objectQualifier = value
        End Set
        Get
            If _objectQualifier = String.Empty Then
                Return DotNetNuke.Data.DataProvider.Instance().ObjectQualifier
            Else
                Return _objectQualifier
            End If
        End Get
    End Property

#End Region

#Region "Private Methods"

    Private Function GetFullyQualifiedName(ByVal name As String) As String
        Return DatabaseOwner & ObjectQualifier & ModuleQualifier & name
    End Function

#End Region

#Region "Public Methods"

    Public Function GetZParentProjectNameZs(ByVal ModuleId As Integer) As IDataReader Implements IDataProvider.GetZParentProjectNameZs
        Return CType(SqlHelper.ExecuteReader(ConnectionString, GetFullyQualifiedName("GetZParentProjectNameZs"), ModuleId), IDataReader)
    End Function

    Public Function GetZParentProjectNameZ(ByVal ModuleId As Integer, ByVal ItemId As Integer) As IDataReader Implements IDataProvider.GetZParentProjectNameZ
        Return CType(SqlHelper.ExecuteReader(ConnectionString, GetFullyQualifiedName("GetZParentProjectNameZ"), ModuleId, ItemId), IDataReader)
    End Function

    Public Function AddZParentProjectNameZ(ByVal ModuleId As Integer, ByVal Content As String, ByVal UserId As Integer) As Integer Implements IDataProvider.AddZParentProjectNameZ
        Return SqlHelper.ExecuteScalar(ConnectionString, GetFullyQualifiedName("AddZParentProjectNameZ"), ModuleId, Content, UserId)
    End Function

    Public Sub UpdateZParentProjectNameZ(ByVal ModuleId As Integer, ByVal ItemId As Integer, ByVal Content As String, ByVal UserId As Integer) Implements IDataProvider.UpdateZParentProjectNameZ
        SqlHelper.ExecuteNonQuery(ConnectionString, GetFullyQualifiedName("UpdateZParentProjectNameZ"), ModuleId, ItemId, Content, UserId)
    End Sub

    Public Sub DeleteZParentProjectNameZ(ByVal ModuleId As Integer, ByVal ItemId As Integer) Implements IDataProvider.DeleteZParentProjectNameZ
        SqlHelper.ExecuteNonQuery(ConnectionString, GetFullyQualifiedName("DeleteZParentProjectNameZ"), ModuleId, ItemId)
    End Sub

#End Region

End Class
